# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from aihub.models.document_details import DocumentDetails
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Conversation(BaseModel):
    """
    Conversation
    """ # noqa: E501
    id: StrictStr = Field(description="Unique identifier for the conversation.")
    name: StrictStr = Field(description="Name of the conversation.")
    description: Optional[StrictStr] = Field(default=None, description="Description of the conversation.")
    state: StrictStr = Field(description="The current state of the conversation.    - `COMPLETE`: Ready to start a conversation.   - `FAILED`: Not able process any of the uploaded files.   - `RUNNING`: Still processing the uploaded files. ")
    documents: Optional[List[DocumentDetails]] = Field(default=None, description="A list of all uploaded and processed documents in the conversation.")
    __properties: ClassVar[List[str]] = ["id", "name", "description", "state", "documents"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Conversation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in documents (list)
        _items = []
        if self.documents:
            for _item in self.documents:
                if _item:
                    _items.append(_item.to_dict())
            _dict['documents'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Conversation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "state": obj.get("state"),
            "documents": [DocumentDetails.from_dict(_item) for _item in obj.get("documents")] if obj.get("documents") is not None else None
        })
        return _obj


