# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DeleteRun202Response(BaseModel):
    """
    DeleteRun202Response
    """ # noqa: E501
    delete_input_dir_job_id: Optional[StrictStr] = Field(default=None, description="Job ID for deleting the input directory.")
    delete_output_dir_job_id: Optional[StrictStr] = Field(default=None, description="Job ID for deleting the output directory.")
    delete_log_dir_job_id: Optional[StrictStr] = Field(default=None, description="Job ID for deleting the log directory.")
    __properties: ClassVar[List[str]] = ["delete_input_dir_job_id", "delete_output_dir_job_id", "delete_log_dir_job_id"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DeleteRun202Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # set to None if delete_input_dir_job_id (nullable) is None
        # and model_fields_set contains the field
        if self.delete_input_dir_job_id is None and "delete_input_dir_job_id" in self.model_fields_set:
            _dict['delete_input_dir_job_id'] = None

        # set to None if delete_output_dir_job_id (nullable) is None
        # and model_fields_set contains the field
        if self.delete_output_dir_job_id is None and "delete_output_dir_job_id" in self.model_fields_set:
            _dict['delete_output_dir_job_id'] = None

        # set to None if delete_log_dir_job_id (nullable) is None
        # and model_fields_set contains the field
        if self.delete_log_dir_job_id is None and "delete_log_dir_job_id" in self.model_fields_set:
            _dict['delete_log_dir_job_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DeleteRun202Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "delete_input_dir_job_id": obj.get("delete_input_dir_job_id"),
            "delete_output_dir_job_id": obj.get("delete_output_dir_job_id"),
            "delete_log_dir_job_id": obj.get("delete_log_dir_job_id")
        })
        return _obj


