# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FieldSourceCoordinates(BaseModel):
    """
    FieldSourceCoordinates
    """ # noqa: E501
    top_x: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Top-left X coordinate of the bounding box.")
    top_y: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Top-left Y coordinate of the bounding box.")
    bottom_x: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Bottom-right X coordinate of the bounding box.")
    bottom_y: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Bottom-right Y coordinate of the bounding box.")
    page_number: Optional[StrictInt] = Field(default=None, description="Zero-indexed page number of the bounding box.")
    __properties: ClassVar[List[str]] = ["top_x", "top_y", "bottom_x", "bottom_y", "page_number"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FieldSourceCoordinates from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FieldSourceCoordinates from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "top_x": obj.get("top_x"),
            "top_y": obj.get("top_y"),
            "bottom_x": obj.get("bottom_x"),
            "bottom_y": obj.get("bottom_y"),
            "page_number": obj.get("page_number")
        })
        return _obj


