# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from aihub.models.list_batch_files_response_nodes_inner_metadata import ListBatchFilesResponseNodesInnerMetadata
from aihub.models.list_batch_files_response_nodes_inner_perms import ListBatchFilesResponseNodesInnerPerms
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ListBatchFilesResponseNodesInner(BaseModel):
    """
    ListBatchFilesResponseNodesInner
    """ # noqa: E501
    full_path: Optional[StrictStr] = Field(default=None, description="Complete path to the file in the storage system.")
    metadata: Optional[ListBatchFilesResponseNodesInnerMetadata] = None
    perms: Optional[ListBatchFilesResponseNodesInnerPerms] = None
    name: Optional[StrictStr] = Field(default=None, description="Name of the file, including optional extension.")
    __properties: ClassVar[List[str]] = ["full_path", "metadata", "perms", "name"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ListBatchFilesResponseNodesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        # override the default output from pydantic by calling `to_dict()` of perms
        if self.perms:
            _dict['perms'] = self.perms.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ListBatchFilesResponseNodesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "full_path": obj.get("full_path"),
            "metadata": ListBatchFilesResponseNodesInnerMetadata.from_dict(obj.get("metadata")) if obj.get("metadata") is not None else None,
            "perms": ListBatchFilesResponseNodesInnerPerms.from_dict(obj.get("perms")) if obj.get("perms") is not None else None,
            "name": obj.get("name")
        })
        return _obj


