# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from aihub.models.query_result import QueryResult
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class QueryStatusResponse(BaseModel):
    """
    QueryStatusResponse
    """ # noqa: E501
    query_id: StrictStr = Field(description="The unique identifier of the query.")
    status: StrictStr = Field(description="Status of the query.")
    results: Optional[List[QueryResult]] = Field(default=None, description="The query response. Returned only if the query status is `COMPLETE`.")
    error: Optional[StrictStr] = Field(default=None, description="Present only if the status is `FAILED`. Contains a message with information about the source of the execution error, such as `\"message\":\"Invalid query uuid passed\"`.")
    __properties: ClassVar[List[str]] = ["query_id", "status", "results", "error"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('RUNNING', 'COMPLETE', 'FAILED'):
            raise ValueError("must be one of enum values ('RUNNING', 'COMPLETE', 'FAILED')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of QueryStatusResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in results (list)
        _items = []
        if self.results:
            for _item in self.results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of QueryStatusResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "query_id": obj.get("query_id"),
            "status": obj.get("status"),
            "results": [QueryResult.from_dict(_item) for _item in obj.get("results")] if obj.get("results") is not None else None,
            "error": obj.get("error")
        })
        return _obj


