# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from aihub.models.run_app_request_settings_keys import RunAppRequestSettingsKeys
from aihub.models.run_app_request_settings_runtime_config import RunAppRequestSettingsRuntimeConfig
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class RunAppRequestSettings(BaseModel):
    """
    JSON object containing settings for the app run.
    """ # noqa: E501
    keys: Optional[RunAppRequestSettingsKeys] = None
    runtime_config: Optional[RunAppRequestSettingsRuntimeConfig] = None
    __properties: ClassVar[List[str]] = ["keys", "runtime_config"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RunAppRequestSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of keys
        if self.keys:
            _dict['keys'] = self.keys.to_dict()
        # override the default output from pydantic by calling `to_dict()` of runtime_config
        if self.runtime_config:
            _dict['runtime_config'] = self.runtime_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of RunAppRequestSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "keys": RunAppRequestSettingsKeys.from_dict(obj.get("keys")) if obj.get("keys") is not None else None,
            "runtime_config": RunAppRequestSettingsRuntimeConfig.from_dict(obj.get("runtime_config")) if obj.get("runtime_config") is not None else None
        })
        return _obj


