# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. Please see https://docs.instabase.com for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class RunQueryRequestSourceAppInner(BaseModel):
    """
    Information of the source app.
    """ # noqa: E501
    type: StrictStr = Field(description="The source app type. For chatbot queries, the app type is always `CHATBOT`.")
    uuid: StrictStr = Field(description="The ID of the source app to query. <Tip> You can query any AI Hub chatbot to which you have access. You can find a chatbot's ID in its AI Hub URL, such as https://aihub.instabase.com/hub/apps/788eba40-5a1f-45f4-ad56-57fb1abe62c7. </Tip> <Note> A chatbot's ID changes with [every version update](/chat/chatbots/#updating-chatbots/). For convenience, when making a request to a given version of a chatbot, the query is always automatically directed to the latest version of the chatbot.</Note>")
    __properties: ClassVar[List[str]] = ["type", "uuid"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('CHATBOT'):
            raise ValueError("must be one of enum values ('CHATBOT')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RunQueryRequestSourceAppInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of RunQueryRequestSourceAppInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type") if obj.get("type") is not None else 'CHATBOT',
            "uuid": obj.get("uuid")
        })
        return _obj


