# coding: utf-8

"""
    AI Hub API

    The AI Hub REST API. See https://docs.instabase.com/api-sdk/ for more details.

    The version of the OpenAPI document: 0.1
    Contact: support@instabase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class UpdateSecretRequest(BaseModel):
    """
    UpdateSecretRequest
    """ # noqa: E501
    alias: StrictStr = Field(description="Name of the secret to update.")
    description: Optional[StrictStr] = Field(default=None, description="New description of the secret.")
    value: Optional[StrictStr] = Field(default=None, description="New content of the secret.")
    allowed_workspaces_type: Optional[StrictStr] = Field(default=None, description="New designation of which workspaces in this organization are allowed to use this secret in custom functions.")
    allowed_workspaces: Optional[List[StrictStr]] = Field(default=None, description="New designation of which workspaces are allowed to use this secret, if only some are.")
    __properties: ClassVar[List[str]] = ["alias", "description", "value", "allowed_workspaces_type", "allowed_workspaces"]

    @field_validator('allowed_workspaces_type')
    def allowed_workspaces_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ALL', 'SOME', 'NONE'):
            raise ValueError("must be one of enum values ('ALL', 'SOME', 'NONE')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of UpdateSecretRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of UpdateSecretRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alias": obj.get("alias"),
            "description": obj.get("description"),
            "value": obj.get("value"),
            "allowed_workspaces_type": obj.get("allowed_workspaces_type"),
            "allowed_workspaces": obj.get("allowed_workspaces")
        })
        return _obj


